Subject: Re: ipv6: Add GSO support on forwarding path

From: Ralf Baechle <[email-masked]>
Date: Wed, 26 May 2010 16:20:19 +0100

On Wed, May 26, 2010 at 08:27:58PM +1000, Herbert Xu wrote:

> ipv6: Add GSO support on forwarding path
> 
> Currently we disallow GSO packets on the IPv6 forward path.
> This patch fixes this.
> 
> Note that I discovered that our existing GSO MTU checks (e.g.,
> IPv4 forwarding) are buggy in that they skip the check altogether, 
> hen they really should be checking gso_size instead.
> 
> I have also been lazy here in that I haven't bothered to segment
> the GSO packet by hand before generating an ICMP message.  Someone
> should add that to be 100% correct.
> 
> Reported-by: Ralf Baechle <[email-masked]>
> Signed-off-by: Herbert Xu <[email-masked]>

I tested this on top of a 2.6.34 release kernel and asked the user
experiencing the problem to re-test and the problem still persists.

Unlike what I told you earlier on IRC my tester can trigger the issue
by going to any page on linux-ax25.org from any XP, Vista or Windows 7
client.

I've got three tcpdumps of the hang occuring on ftp.linux-ax25.org

  /pub/dl1bff.log
  /pub/dl1bff-2.log
  /pub/dl1bff-3.log

The first two were taken with a 2.6.32 Fedora 12 kernel; the 3rd with
a stock 2.6.34 kernel and your patch applied on top.  The issue exists
for quite a while; it has first been noticed with Fedora 11.

  Ralf